// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_NOTEBOOK_H
#define _GTKMM_NOTEBOOK_H

#include <glibmm.h>

/* $Id: notebook.hg,v 1.37 2002/05/04 20:40:34 murrayc Exp $ */

/* notebook.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/container.h>
#include <gtkmm/label.h>
#include <gtk/gtknotebook.h> //Needed for GtkNotebookPage
#include <glibmm/helperlist.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkNotebook GtkNotebook;
typedef struct _GtkNotebookClass GtkNotebookClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class Notebook_Class; } // namespace Gtk
namespace Gtk
{


/** @addtogroup gtkmmEnums Enums and Flags */

/**
 * @ingroup gtkmmEnums
 */
enum NotebookTab
{
  NOTEBOOK_TAB_FIRST,
  NOTEBOOK_TAB_LAST
};

} // namespace Gtk

#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gtk::NotebookTab> : public Glib::Value_Enum<Gtk::NotebookTab>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{


/** container which shows one of its children at a time, in tabbed windows.
 *
 * @ingroup Widgets
 * @ingroup Containers
 */

class Notebook : public Container
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Notebook CppObjectType;
  typedef Notebook_Class CppClassType;
  typedef GtkNotebook BaseObjectType;
  typedef GtkNotebookClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Notebook();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class Notebook_Class;
  static CppClassType notebook_class_;

  Notebook(const Notebook&);
  Notebook& operator=(const Notebook&); // not implemented

protected:
  explicit Notebook(GtkNotebook* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkNotebook* gobj()             { return (GtkNotebook*)(gobject_); }
  const GtkNotebook* gobj() const { return (GtkNotebook*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_switch_page(GtkNotebookPage* page, guint page_num);
  virtual bool on_select_page(bool move_focus);
  virtual bool on_focus_tab(NotebookTab type);
  virtual void on_change_current_page(int offset);
  virtual void on_move_focus_out(DirectionType direction);


private:

  
public:
  Notebook();

  
  void prepend_page(Widget& child, Widget& tab_label);
  void prepend_page(Widget& child, const Glib::ustring& tab_label, bool use_mnemonic = false);
  
  void prepend_page(Widget& child, Widget& tab_label, Widget& menu_label);
  void prepend_page(Widget& child, const Glib::ustring& tab_label, const Glib::ustring& menu_label, bool use_mnemonic);

  
  void append_page(Widget& child, Widget& tab_label);
  void append_page(Widget& child, const Glib::ustring& tab_label, bool use_mnemonic = false);
  
  void append_page(Widget& child, Widget& tab_label, Widget& menu_label);
  void append_page(Widget& child, const Glib::ustring& tab_label, const Glib::ustring& menu_label, bool use_mnemonic = false);

  
  void insert_page(Widget& child, Widget& tab_label, int position);
  void insert_page(Widget& child, const Glib::ustring& tab_label, int position, bool use_mnemonic = false);
  
  void insert_page(Widget& child, Widget& tab_label, Widget& menu_label, int position);
  void insert_page(Widget& child, const Glib::ustring& tab_label, const Glib::ustring& menu_label, int position, bool use_mnemonic = false);


  void remove_page(int page_num = 0);
  void remove_page(Widget& child);

  
  int get_current_page_num() const;
  
  Widget* get_nth_page(int page_number);
  Widget* get_current_page();
  
  int page_num(const Widget& child);

  
  void set_current_page(int page_number);
  
  void next_page();
  
  void prev_page();

  
  void set_show_border(bool show_border = true);

  
  bool get_show_border() const;
  
  void set_show_tabs(bool show_tabs = true);
  
  bool get_show_tabs() const;


  void set_tab_pos(PositionType pos);
  
  PositionType get_tab_pos() const;

  
  void set_scrollable(bool scrollable = true);
  
  bool get_scrollable() const;

  
  void popup_enable();

  
  void popup_disable();


  Widget* get_tab_label( Widget& child);
  
  void set_tab_label( Widget& child, Widget& tab_label);
  
  void set_tab_label_text(Widget& child, const Glib::ustring& tab_text);
  
  Glib::ustring get_tab_label_text(Widget& child) const;
  
  Widget* get_menu_label (Widget& child);
  
  void set_menu_label(Widget& child, Widget& menu_label);
  
  void set_menu_label_text(Widget& child, const Glib::ustring& menu_text);
  
  Glib::ustring get_menu_label_text(Widget& child) const;
  void query_tab_label_packing(Widget& child, bool& expand, bool& fill, PackType& pack_type);
  
  
  void set_tab_label_packing (Widget& child, bool expand, bool fill, PackType pack_type);
  
  void reorder_child(Widget& child, int position);


  /**
   * @par Prototype:
   * <tt>void %switch_page(GtkNotebookPage* page, guint page_num)</tt>
   */
  Glib::SignalProxy2<void,GtkNotebookPage*,guint> signal_switch_page();


  /**
   * @par Prototype:
   * <tt>bool %select_page(bool move_focus)</tt>
   */
  Glib::SignalProxy1<bool,bool> signal_select_page();

  
  /**
   * @par Prototype:
   * <tt>bool %focus_tab(NotebookTab type)</tt>
   */
  Glib::SignalProxy1<bool,NotebookTab> signal_focus_tab();

  
  /**
   * @par Prototype:
   * <tt>void %change_current_page(int offset)</tt>
   */
  Glib::SignalProxy1<void,int> signal_change_current_page();

  
  /**
   * @par Prototype:
   * <tt>void %move_focus_out(DirectionType direction)</tt>
   */
  Glib::SignalProxy1<void,DirectionType> signal_move_focus_out();


  Glib::PropertyProxy<PositionType> property_tab_pos();

  Glib::PropertyProxy<bool> property_show_tabs();

  Glib::PropertyProxy<bool> property_show_border();

  Glib::PropertyProxy<bool> property_scrollable();

  Glib::PropertyProxy_WriteOnly<guint> property_tab_border();

  Glib::PropertyProxy<guint> property_tab_hborder();

  Glib::PropertyProxy<guint> property_tab_vborder();

  Glib::PropertyProxy<int> property_page();

  Glib::PropertyProxy<bool> property_enable_popup();

  Glib::PropertyProxy<bool> property_homogeneous();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Notebook */
  Gtk::Notebook* wrap(GtkNotebook* object, bool take_copy = false);
}
#endif /* _GTKMM_NOTEBOOK_H */

